	TITLE ASMCOS
	.386
	.MODEL	FLAT,pascal
	.CODE

; bekommt auf ST(0) das argument.
; schneidet alle Ziffern nach dem Komma ab.
; Legt das Ergebnis wieder auf ST(0)

trunc proc
  push ebp                    ; Funktions-Prolog
  
  mov ebp,esp
  sub esp,10                  ; Platz fuer 80Bit FPU Zahl

  fstp tbyte ptr [ebp-10]     ; Argument in lokale Variable
  mov ax,[ebp-2]              ; Exponent UND Vorzeichen nach ax

  and ax,07FFFh               ; Vorzeichen in ax loeschen 
  sub ax,16383                ; Realen Exponent berechnen

  JB make_zero                ; ax < 16383  => Rundungs-Ergebnis = 0.0
  cmp ax,62
  JA make_nothing             ; ax >= 63    => Komma ausserhalb von Mantisse
  mov cx,63
  sub cx,ax                   ; cx = 63 - ax = zu schreibende 0 bits
  mov edx,-10 

round_loop:
  cmp cx,8
  JB finish_zeros             ; CX >= 8  => Gleich ein ganzes Byte auf 0
  mov byte ptr [ebp+edx],0
  inc edx
  sub cx,8                    ; 8 Bits weniger
  jmp round_loop

finish_zeros:
  mov ah,0FFh              
  shl ah,cl                   ; ax = 111 ... 0 cl mal (bsp cx=3 => ax=11111000)
  and byte ptr [ebp+edx],ah   ; Uebrige bits auf 0 setzen 

make_nothing:                 ; Einsprung fuer "falls nichts zu tun"
  fld tbyte ptr [ebp-10]      ; Gerundete Zahl wieder auf den FPU stack
  
  mov esp,ebp                 ; Funktions-Epilog
  pop ebp
  ret

make_zero:
  fldz                        ; Ergebnis = 0.0
  
  mov esp,ebp                 ; Funktions-Epilog
  pop ebp
  ret
trunc endp
                
PI       db 53,194,104,33,162,218,15,201,0,64
PImal2   db 53,194,104,33,162,218,15,201,1,64

fakult   db 15,214,71,80,44,147,51,185  ;    -1/30!
         db 94,8,53,38,138,161,208,57  ;     1/28!
         db 90,78,106,252,133,142,104,186  ;    -1/26!
         db 120,245,114,25,240,44,255,58  ;     1/24!
         db 83,248,183,109,57,206,144,187  ;    -1/22!
         db 38,2,2,164,43,84,30,60  ;     1/20!
         db 152,125,185,99,120,130,166,188  ;    -1/18!
         db 32,184,51,231,243,231,42,61  ;     1/16!
         db 158,124,192,168,116,57,169,189  ;    -1/14!
         db 152,216,248,239,216,238,33,62  ;     1/12!
         db 93,159,120,183,79,126,146,190  ;    -1/10!
         db 26,160,1,26,160,1,250,62  ;     1/8!
         db 23,108,193,22,108,193,86,191  ;    -1/6!
         db 85,85,85,85,85,85,165,63  ;     1/4!
         db 0,0,0,0,0,0,224,191  ;    -1/2!
         db 0,0,0,0,0,0,240,63  ;     1


; unsere Funktion zum Berechnen des Cosinus
public _ASMCos
_asmcos proc
  
; initialierung
  ARG a:qword	
  xor eax,eax
	fninit				
	
; parameter modulo 2*PI berechnen	und davon PI abziehen
 	fld a                       ; parameter 2 * auf den FPU stack
 	fabs
 	fld st(0)                       	
  fld tbyte ptr PImal2        ; 2*PI auf den FPU stack
  fdivp st(1),st              ; parameter durch 2*PI dividieren
  call trunc                  ; Ergebnis runden!
	fld tbyte ptr PImal2        ; 2*PI auf den FPU Stack
	fmulp st(1),st 		          ; Gerundetes Erg * 2*PI
  fsubp st(1),st              ; parameter -  (Gerundetes Erg * 2*PI)
	fld tbyte ptr PI            ; PI auf den FPU Stack
  fsubp st(1),st              ; |parameter modulo 2*PI| - PI

  
; so jetzt knnen wir den Cosinus berechnen
	fmul st,st(0)               ; zuerst wird x^2 berechnet  
  fld st(0)                   ; und ein zweites mal speichern
  
  lea eax,fakult              ; offset von fakult ermitteln
	mov ecx,14                  ; schleifenvariable initialieren
  fmul qword ptr [eax]        ; x^2 mit dem kleinsten wert von fakult
                              ; multiplizieren
l1:
	dec ecx                     
	add eax,8                   ; auf neue fakult zahl positionieren
	fadd qword ptr [eax]        ; und addieren
	fmul st,st(1)               ; mit x^2 multipizieren
	cmp ecx, 0                  ; Schleife schon fertig?
	jne l1

	add eax,8
	fadd qword ptr [eax]        ; noch das letzte + 1 hinzuzhlen
	
	ffree st(1)                 ; x^2 freigeben
  
  fchs                        ; so jetzt noch das vorzeichen ndern

  ret                         ; und zurck
_asmcos endp

end


